

window.addEventListener("load",function() {initAutoCopyStatus();} ,true);
window.addEventListener("focus",function() {resetAutoCopyStatus();} ,true);




function autocopyContextHide() {
	var cm = gContextMenu;
	var AutocopyFirebirdcontextmenuitem = document.getElementById('autocopy-firebirdcontextmenuitem');

	if(autocopyPrefs.getBoolPref("optContextMenuItem")){
		AutocopyFirebirdcontextmenuitem.hidden = ( cm.onImage || cm.onLink || cm.onTextInput );
		//|| cm.onLink || cm.onImage || cm.onTextInput );
	}
	else{
	    AutocopyFirebirdcontextmenuitem.hidden = true;
	}
}


function setAutoCopyStatus()
{
	if(autocopyPrefs.getBoolPref("optStatusBar")){
		var autocopy = document.getElementById('autocopy-status');
		var tooltip = document.getElementById('autocopy-tooltip-value');
		autocopy.setAttribute("status", enabled);	

	    	var strings = document.getElementById("autocopyStrings");

		tooltip.setAttribute("value", strings.getString("statusbar-tooltip-enabled"));
	}
}



function initAutoCopyStatus() 
{

        initPreferences();

	document.getElementById("contentAreaContextMenu").addEventListener("popupshowing",autocopyContextHide,false);
        
	document.getElementById("cmd_selectAll").setAttribute("oncommand", "goDoCommand('cmd_selectAll'); AutocopySelectAll();");


    	var strings = document.getElementById("autocopyStrings");

	var autocopyLocalizationPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.{0FED7D55-65D4-47b6-A6DE-9A4ADB55355F}.");
	var autocopylocaledescription = strings.getString("autocopy-description");
	var str = Components.classes[ "@mozilla.org/supports-string;1" ].createInstance( Components.interfaces.nsISupportsString );
	str.data = autocopylocaledescription;
	autocopyLocalizationPrefs.setComplexValue( "description", Components.interfaces.nsISupportsString, str );
  

	var autocopyStatusBarButton = document.getElementById('autocopy-status');
	
	var autocopyStatusBarButtonTooltip = document.getElementById('autocopy-tooltip-value');

	var Autocopyfirebirdkeytoggleautocopyenabled = document.getElementById('firebirdkey-toggle-autocopyenabled');
	var AutocopyFirebirdmenuitem = document.getElementById('autocopy-firebirdmenuitem');
	var AutocopyFirebirdmenuitemseparator = document.getElementById('autocopy-firebirdmenuitemseparator');
	var AutocopyFirebirdcontextmenuitem = document.getElementById('autocopy-firebirdcontextmenuitem');

	if(autocopyPrefs.getBoolPref("optStatusBar")){
            autocopyStatusBarButton.setAttribute("hidden", false);
        }
        else{
            autocopyStatusBarButton.setAttribute("hidden", true);
        }

        if(autocopyPrefs.getBoolPref("optEditMenuItem")){
	    AutocopyFirebirdmenuitemseparator.setAttribute("hidden", false);
            AutocopyFirebirdmenuitem.setAttribute("hidden", false);
        }
        else{
	    AutocopyFirebirdmenuitemseparator.setAttribute("hidden", true);
            AutocopyFirebirdmenuitem.setAttribute("hidden", true);
        }


        if(autocopyPrefs.getBoolPref("optKeyboardShortcutEnabled")){
    
            var optModifiers = "";
            if(autocopyPrefs.getBoolPref("optKeyboardShortcutKeyAccel"))
                optModifiers = optModifiers + ",accel";
            if(autocopyPrefs.getBoolPref("optKeyboardShortcutKeyMeta"))
                optModifiers = optModifiers + ",meta";
            if(autocopyPrefs.getBoolPref("optKeyboardShortcutKeyCtrl"))
                optModifiers = optModifiers + ",control";
            if(autocopyPrefs.getBoolPref("optKeyboardShortcutKeyShift"))
                optModifiers = optModifiers + ",shift";
            if(autocopyPrefs.getBoolPref("optKeyboardShortcutKeyAlt"))
                optModifiers = optModifiers + ",alt";
                
            optModifiers.replace(/^\,/,"");
        
            var optKey = autocopyPrefs.getCharPref("optKeyboardShortcutKey");
            if(optKey.match(/^[A-Z]$/i)){
                Autocopyfirebirdkeytoggleautocopyenabled.setAttribute("key", optKey);
                Autocopyfirebirdkeytoggleautocopyenabled.setAttribute("keycode", "");
            }
            else{
                Autocopyfirebirdkeytoggleautocopyenabled.setAttribute("key", "");
                Autocopyfirebirdkeytoggleautocopyenabled.setAttribute("keycode", optKey);
            }
            
            Autocopyfirebirdkeytoggleautocopyenabled.setAttribute("modifiers", optModifiers);
            Autocopyfirebirdkeytoggleautocopyenabled.setAttribute("disabled", false);
        }
        else{
            Autocopyfirebirdkeytoggleautocopyenabled.setAttribute("disabled", true);
        }

	if (autocopyPrefs.getIntPref("StatusBarState") == 0)
        {
		 AutocopyFirebirdcontextmenuitem.setAttribute("checked", false);
                 AutocopyFirebirdmenuitem.setAttribute("checked", false);
		 if(autocopyPrefs.getBoolPref("optStatusBar")){
	                 autocopyStatusBarButton.setAttribute("status", "disabled");
        	         autocopyStatusBarButtonTooltip.setAttribute("value", strings.getString("statusbar-tooltip-disabled"));
        	 }
	}
	else
	{
		 AutocopyFirebirdcontextmenuitem.setAttribute("checked", true);
                 AutocopyFirebirdmenuitem.setAttribute("checked", true);
		 if(autocopyPrefs.getBoolPref("optStatusBar")){
                 	autocopyStatusBarButton.setAttribute("status", "enabled");
                 	autocopyStatusBarButtonTooltip.setAttribute("value", strings.getString("statusbar-tooltip-enabled"));
		 }
	}
}



function resetAutoCopyStatus()
{
    initAutoCopyStatus()
}




function initPreferences(){

	if (!autocopyPrefs.prefHasUserValue("StatusBarState"))
		autocopyPrefs.setIntPref("StatusBarState", 1)

	if (!autocopyPrefs.prefHasUserValue("optPasteOnMiddleClick"))
		autocopyPrefs.setBoolPref("optPasteOnMiddleClick", true);
	if (!autocopyPrefs.prefHasUserValue("optDeselectAfterCopy"))
		autocopyPrefs.setBoolPref("optDeselectAfterCopy", true);
	if (!autocopyPrefs.prefHasUserValue("optStatusBar"))
		autocopyPrefs.setBoolPref("optStatusBar", true);
	if (!autocopyPrefs.prefHasUserValue("optEditMenuItem"))
		autocopyPrefs.setBoolPref("optEditMenuItem", true);
	if (!autocopyPrefs.prefHasUserValue("optContextMenuItem"))
		autocopyPrefs.setBoolPref("optContextMenuItem", false);
	if (!autocopyPrefs.prefHasUserValue("optEnableInTextBoxes"))
		autocopyPrefs.setBoolPref("optEnableInTextBoxes", false);
	if (!autocopyPrefs.prefHasUserValue("optKeyboardShortcutEnabled"))
		autocopyPrefs.setBoolPref("optKeyboardShortcutEnabled", true);

	if (!autocopyPrefs.prefHasUserValue("optKeyboardShortcutKeyAccel"))
		autocopyPrefs.setBoolPref("optKeyboardShortcutKeyAccel", false);
	if (!autocopyPrefs.prefHasUserValue("optKeyboardShortcutKeyMeta"))
		autocopyPrefs.setBoolPref("optKeyboardShortcutKeyMeta", false);
	if (!autocopyPrefs.prefHasUserValue("optKeyboardShortcutKeyCtrl"))
		autocopyPrefs.setBoolPref("optKeyboardShortcutKeyCtrl", true);
	if (!autocopyPrefs.prefHasUserValue("optKeyboardShortcutKeyShift"))
		autocopyPrefs.setBoolPref("optKeyboardShortcutKeyShift", true);
	if (!autocopyPrefs.prefHasUserValue("optKeyboardShortcutKeyAlt"))
		autocopyPrefs.setBoolPref("optKeyboardShortcutKeyAlt", false);
	if (!autocopyPrefs.prefHasUserValue("optKeyboardShortcutKey"))
		autocopyPrefs.setCharPref("optKeyboardShortcutKey", "C");
}




function switchautocopystatusstate()
{
        if (autocopyPrefs.getIntPref("StatusBarState") == 0)
        {
		autocopyPrefs.setIntPref("StatusBarState", 1);
        }
        else
        {
		autocopyPrefs.setIntPref("StatusBarState", 0);
        }
        initAutoCopyStatus();
}



// prefs
var autocopyPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("autocopy.");

if (!autocopyPrefs.prefHasUserValue("StatusBarState"))
	autocopyPrefs.setIntPref("StatusBarState", 1)


window.onmouseup = autocopyOnMouseUp;
window.onkeyup = onKeyUpCheck;


function onKeyUpCheck(e)
{
	if(e.keyCode == e.DOM_VK_A && e.ctrlKey)
	{
		autocopyOnMouseUp(e);
	}
}


function autocopyOnMouseUp(e){
   
   var targetclassname = e.target.toString();
   if(autocopyPrefs.getIntPref("StatusBarState") == 1){
	if (!targetclassname.match(/object XUL/i))
	{
		if(!targetclassname.match(/SelectElement|OptionElement/i))
		{
			if(!targetclassname.match(/InputElement|TextAreaElement/i) || autocopyPrefs.getBoolPref("optEnableInTextBoxes"))
			{
				goDoCommand('cmd_copy');
				if(autocopyPrefs.getBoolPref("optDeselectAfterCopy"))
				{
					goDoCommand('cmd_selectNone');
				}
			}
		}
	}
   }

   if(autocopyPrefs.getBoolPref("optPasteOnMiddleClick"))
   {

	if(e.button == 1)
	{
		goDoCommand('cmd_paste');
	}
    }
}


function AutocopySelectAll(){
   if(autocopyPrefs.getIntPref("StatusBarState") == 1)
   {
	goDoCommand('cmd_copy');
	if(autocopyPrefs.getBoolPref("optDeselectAfterCopy"))
	{
		goDoCommand('cmd_selectNone');
	}
   }
}


